
;#########################################################################
;
; Modified and Extended By Elias Tsiantas - elias_t [25/6/03]
; Particle system based on simon@acid's single surface particle system
; uses tris instead of quads
;
; GRASS SYSTEM BASED ON JFK'S[DIETER MARFURT] GRASS DEMO
;
; Z-ORDER FIX BY MASTER BEAKER
;
;-------------------------------------------------------------------------
;
; version d [14/10/03]
;
; In this version a *.ord file is saved after the first run so there is no
; need to recalculate the z-order banks if the *.ord file is detected.
; If you change the no. of particles the banks will be recalculated.
;
; Also I have added support for grassmaps.If a grassmap is declared
; the function will add grass only on green painted areas of the grassmap.
; You should paint the grassmap with green color on a copy of the original
; heightmap and keep the same imagesize.
;
; I added back in vertex coloring of the particles.
; A future use of this could be: If you use a lightmapped terrain
; use the shadowmap values to light accordingly the particles...
;
;#########################################################################




Include "ssps_g.bb";the psys [grass version]


Include "alfa_zorder.bb";By Master Beaker


;Frame limiting code setup 
Global gameFPS 		= 30 
Global framePeriod 	= 1000 / gameFPS 
Global frameTime 	= MilliSecs () - framePeriod 
Global frameTween#  = 1.0


;camera globals
Global FL_Pitch#,FL_Yaw#,FL_Roll#
Global FL_XSpeed#,FL_YSpeed#,FL_ZSpeed#
Global speed#=0.18



Graphics3D 800,600,32,1


SetBuffer BackBuffer()
Text 320,210,"No more cups of tea needed",True
Flip

HidePointer

camera=CreateCamera()
TranslateEntity camera,0,100,0
CameraClsColor camera,80,110,120
CameraFogMode camera,1
CameraFogColor camera,80,110,120
CameraFogRange camera,100,250
CameraRange camera,1,252


;li=CreateLight(2)
;LightColor li,100,100,100
;PositionEntity li,200,100,200

li=CreateLight()





;load the terrain wich will be used to spread the grass on it

terscale#=5.0;declare the terrain scale !!!

terrain=LoadTerrain("hmap.jpg")
ScaleEntity terrain,terscale#,100,terscale#
TranslateEntity terrain,-320,0,-320
floortex=LoadTexture("floor.jpg")
ScaleTexture floortex,32/terscale#,32/terscale#
EntityTexture terrain,floortex







st=MilliSecs()

;MAKE THE GRASS EMITTER
gr.grass=New grass
gr\id=1					;the grass id
gr\tris=3000			;no. of individual plants [->also no. of tris]
gr\tex$="grass5f.tga"	;the plant texture
gr\grassmap$="gmap.png"	;the grassmap
gr\texflag=2+16+32		;the texture flag
gr\fx=1+2+16			;the fx flag [+2 = enable vertex coloring]
gr\blend=1				;the blend mode flag
gr\alpha=1				;alpha value
gr\r=255:gr\g=255:gr\b=255;vertex coloring rgb values

gr\size=5.0				;the size of the plant
gr\size2=35.0			;varies size between size and size2 [if size2>0]



;the z-order bin file to use
;once saved the *.ord file will be used instead of constructing it
gr\z$="z.ord"

;-------------------------------
;Make the grass on this terrain
GRASS_MAKE(terrain,terscale)
;-------------------------------






;#########################################################################

et=MilliSecs()
dt=et-st


MoveMouse GraphicsWidth()/2,GraphicsHeight()/2




;MAIN LOOP

While Not KeyHit(1)


	; Frame limiting 
	Repeat 
		frameElapsed = MilliSecs () - frameTime 
	Until frameElapsed 
	frameTicks = frameElapsed / framePeriod 
	frameTween# = Float (frameElapsed Mod framePeriod) / Float (framePeriod) 

	
	; Update game and world state 
	For frameLimit = 1 To frameTicks 
		If frameLimit = frameTicks Then CaptureWorld 
		frameTime = frameTime + framePeriod 

		UpdateWorld

;--------------------------------------------------------


;UPDATE WIND
For gr.grass = Each grass:Updatewind(gr\hndl):Next

;UPDATE Z-ORDER
For zo.zorder = Each zorder:SortAlpha(zo,camera):Next



FreeLook (camera)

;-------------------------------------------------------

	Next
			
 	RenderWorld frameTween




;destroy the grass collection with id=1 when pressing the [1] key
If KeyHit(2) Destroy_plant(1)



	Text 10,0,"wsadrf=move , mouse=look"
	Text 10,14,"tris:"+TrisRendered()
	Text 10,28,"fps :"+fps2
	Text 10,40,"It took: "+dt+" millisecs"

	
	;fps
	fps=fps+1
	If fps_t<MilliSecs()
	fps2=fps
	fps_t=1000+MilliSecs()
	fps=0
	EndIf


	Flip 0
		
Wend


;destroy all grass emitters
Destroy_grass()

ClearWorld
EndGraphics
End





;#########################################################################



Function FreeLook(FL_Cam)

FL_Pitch#=FL_Pitch#-(MouseYSpeed()*0.02)
FL_Pitch#=FL_Pitch#/1.2
FL_Yaw#=FL_Yaw#+-(MouseXSpeed()*0.02)
FL_Yaw#=FL_Yaw#/1.2
MoveMouse (GraphicsWidth()/2,GraphicsHeight()/2)
FL_ZSpeed#=FL_ZSpeed#+Float(KeyDown(17)-KeyDown(31))*speed# ; W & S
FL_ZSpeed#=FL_ZSpeed#/1.14
FL_XSpeed#=FL_XSpeed#+Float(KeyDown(32)-KeyDown(30))*speed# ; A & D
FL_XSpeed#=FL_XSpeed#/1.14
FL_YSpeed#=FL_YSpeed#+Float(KeyDown(19)-KeyDown(33))*speed# ; R & F
FL_YSpeed#=FL_YSpeed#/1.14
FL_Roll#=(FL_Yaw#*speed#)-(FL_XSpeed#*1.7)
MoveEntity FL_Cam,FL_XSpeed#,FL_YSpeed#+Abs(FL_Roll#*FL_XSpeed#)/50,FL_ZSpeed#
Local cp#=EntityPitch(FL_Cam,True)+FL_Pitch#
If cp<-89 Then cp=-89
If cp>89 Then cp=89
RotateEntity FL_Cam,cp,EntityYaw(FL_Cam)+FL_Yaw#,FL_Roll#

End Function
;-------------------